from apps.product.web.api.v1.serializers import quota_distribution_serializers
from apps.product.services.services import get_products_in_warehouse
from apps.product.web.api.v1.serializers import quota_serializers
from apps.core.mixins.soft_delete_mixin import SoftDeleteMixin
from apps.product.exceptions import QuotaExpiredTimeException
from apps.core.mixins.search_mixin import DynamicSearchMixin
from apps.core.pagination import CustomPageNumberPagination
from apps.product.web.api.v1.viewsets import product_api
from common.helpers import get_organization_by_user
from rest_framework.exceptions import APIException
from apps.product import models as product_models
from rest_framework.response import Response
from rest_framework.decorators import action
from common.tools import CustomOperations
from rest_framework import viewsets, filters
from rest_framework import status
from django.db import transaction
from django.db.models import Q
from datetime import datetime


def trash(queryset, pk):  # noqa
    """ sent object to trash """
    obj = queryset.get(id=pk)
    obj.trash = True
    obj.save()


def delete(queryset, pk):
    """ full delete object """
    obj = queryset.get(id=pk)
    obj.delete()


class QuotaViewSet(viewsets.ModelViewSet, DynamicSearchMixin, SoftDeleteMixin):  # noqa
    """ apis for product quota """

    queryset = product_models.Quota.objects.all()
    serializer_class = quota_serializers.QuotaSerializer
    filter_backends = [filters.SearchFilter]
    CustomPageNumberPagination.page_size = 5
    search_fields = [
        "registerer_organization__name",
        "quota_id",
        "product__name",
        "sale_type",
        "sale_unit__unit",
        "group",
    ]

    @transaction.atomic
    def create(self, request, *args, **kwargs):
        """ custom create quota """

        # get user relations data like organization
        user_relation = request.user.user_relation.all().first()

        # add user relation to data
        if user_relation.organization:
            request.data['registerer_organization'] = user_relation.organization.id
        else:
            raise APIException("برای این کاربر سازمانی تعریف نشده است")  # noqa

        # create quota
        serializer = self.serializer_class(data=request.data)
        if serializer.is_valid():
            quota = serializer.save()
            quota.remaining_weight = quota.quota_weight

            # create incentive plan
            plans_list = []
            if 'incentive_plan_data' in request.data.keys():
                for plan in request.data['incentive_plan_data']:
                    plan.update({'quota': quota.id})
                    incentive_plan = CustomOperations().custom_create(
                        request=request,
                        view=QuotaIncentiveAssignmentViewSet(),
                        data_key='incentive_plan_data',
                        data=plan
                    )
                    plans_list.append(incentive_plan)

            # create product price attributes for quota
            attributes_value_list = []
            if 'price_attributes_data' in request.data.keys():
                for attr in request.data['price_attributes_data']:
                    attr.update({'quota': quota.id})
                    attributes = CustomOperations().custom_create(
                        request=request,
                        view=product_api.AttributeValueViewSet(),
                        data=attr
                    )
                    attributes_value_list.append(attributes)

            # create product broker values for quota
            broker_data_list = []
            if 'broker_data' in request.data.keys():
                for broker in request.data['broker_data']:
                    broker.update({'quota': quota.id})
                    broker_value = CustomOperations().custom_create(
                        request=request,
                        view=QuotaBrokerValueViewSet(),
                        data=broker
                    )
                    broker_data_list.append(broker_value)

            # create livestock allocations to quota
            allocations_list = []
            if 'livestock_allocation_data' in request.data.keys():
                for ls_alloc in request.data['livestock_allocation_data']:
                    ls_alloc.update({'quota': quota.id})
                    allocations = CustomOperations().custom_create(
                        request=request,
                        view=QuotaLiveStockAllocationViewSet(),
                        data=ls_alloc
                    )
                    allocations_list.append(allocations)

            # create livestock age limits for quota
            livestock_age_limits = []
            if 'livestock_age_limitations' in request.data.keys():
                for age_limit in request.data['livestock_age_limitations']:
                    age_limit.update({'quota': quota.id})
                    age_limit_creation_object = CustomOperations().custom_create(
                        request=request,
                        view=QuotaLiveStockAgeLimitation(),
                        data=age_limit
                    )
                    livestock_age_limits.append(age_limit_creation_object)

            data = {
                'quota': serializer.data,
                'incentive_plan': plans_list,  # noqa
                'attribute_values': attributes_value_list,
                'broker_values': broker_data_list,
                'live_stock_allocations': allocations_list,
                'livestock_age_limitations': livestock_age_limits
            }

            # call save method to generate id & calculate quota final price
            quota.save(calculate_final_price=True)
            return Response(data, status=status.HTTP_201_CREATED)
        return Response(serializer.errors, status=status.HTTP_403_FORBIDDEN)

    @transaction.atomic
    def update(self, request, pk=None, *args, **kwargs):
        # get user relations data like organization
        user_relation = request.user.user_relation.all().first()

        # add user relation to data
        request.data['registerer_organization'] = user_relation.organization.id

        # create quota
        serializer = self.serializer_class(data=request.data, instance=self.get_object(), partial=True)
        if serializer.is_valid():
            quota = serializer.save()

            # create incentive plan
            plans_list = []
            if 'incentive_plan_data' in request.data.keys():

                # remove all incentive assignment relations
                quota.incentive_assignments.all().delete()

                for plan in request.data['incentive_plan_data']:
                    # create new relations
                    plan.update({'quota': quota.id})
                    incentive_plan = CustomOperations().custom_create(
                        request=request,
                        view=QuotaIncentiveAssignmentViewSet(),
                        data_key='incentive_plan_data',
                        data=plan
                    )
                    plans_list.append(incentive_plan)

            # create product price attributes for quota
            attributes_value_list = []  # noqa
            if 'price_attributes_data' in request.data.keys():

                # remove all price attribute relations
                quota.attribute_values.all().delete()

                for attr in request.data['price_attributes_data']:
                    # create new relations
                    attr.update({'quota': quota.id})
                    attributes = CustomOperations().custom_create(
                        request=request,
                        view=product_api.AttributeValueViewSet(),
                        data=attr
                    )
                    attributes_value_list.append(attributes)

            # create product broker values for quota
            broker_data_list = []  # noqa
            if 'broker_data' in request.data.keys():

                # remove broker values relations
                quota.broker_values.all().delete()

                for broker in request.data['broker_data']:
                    # create new relations
                    broker.update({'quota': quota.id})
                    broker_value = CustomOperations().custom_create(
                        request=request,
                        view=QuotaBrokerValueViewSet(),
                        data=broker
                    )
                    broker_data_list.append(broker_value)

            # create livestock allocations to quota
            allocations_list = []
            if 'livestock_allocation_data' in request.data.keys():

                # remove livestock allocations data relations
                quota.livestock_allocations.all().delete()

                for ls_alloc in request.data['livestock_allocation_data']:
                    # create new relations
                    ls_alloc.update({'quota': quota.id})
                    allocations = CustomOperations().custom_create(
                        request=request,
                        view=QuotaLiveStockAllocationViewSet(),
                        data=ls_alloc
                    )
                    allocations_list.append(allocations)

            # create livestock age limits for quota
            livestock_age_limits = []
            if 'livestock_age_limitations' in request.data.keys():

                # remove live stock age limit relations
                quota.livestock_age_limitations.all().delete()

                for age_limit in request.data['livestock_age_limitations']:
                    # create new relations
                    age_limit.update({'quota': quota.id})
                    age_limit_creation_object = CustomOperations().custom_create(
                        request=request,
                        view=QuotaLiveStockAgeLimitation(),
                        data=age_limit
                    )
                    livestock_age_limits.append(age_limit_creation_object)

            data = {
                'quota': serializer.data,
                'incentive_plan': plans_list,  # noqa
                'attribute_values': attributes_value_list,
                'broker_values': broker_data_list,
                'live_stock_allocations': allocations_list,
                'livestock_age_limitations': livestock_age_limits
            }

            # call save method to generate id & calculate quota final price
            quota.save(calculate_final_price=True)
            return Response(data, status=status.HTTP_201_CREATED)
        return Response(serializer.errors, status=status.HTTP_403_FORBIDDEN)

    @action(
        methods=['patch'],
        detail=True,
        url_path='close',
        url_name='close',
        name='close'
    )
    @transaction.atomic
    def close(self, request, pk=None):
        """ to close quota """
        quota = self.get_object()

        # check quota expired time
        if not quota.is_in_valid_time():
            raise QuotaExpiredTimeException()

        if quota.is_closed:
            raise APIException("این سهمیه قبلا بسته شده است", status.HTTP_400_BAD_REQUEST)  # noqa

        quota.is_closed = True
        quota.closed_at = datetime.now()
        quota.save()

        return Response(status.HTTP_200_OK)

    @action(
        methods=['patch'],
        detail=True,
        url_path='activate',
        url_name='activate',
        name='activate'
    )
    def activate(self, request, pk=None):
        """ to activate quota """

        quota = self.get_object()

        # check quota expired time
        if not quota.is_in_valid_time():
            raise QuotaExpiredTimeException()

        if not quota.is_closed:
            raise APIException("این سهمیه از قبل فعال است", status.HTTP_400_BAD_REQUEST)

        quota.is_closed = False
        quota.save()
        return Response(status=status.HTTP_200_OK)

    @action(
        methods=['get'],
        detail=False,
        url_path='active_quotas',
        url_name='active_quotas',
        name='active_quotas'
    )
    @transaction.atomic
    def active_quotas(self, request):
        """ list of organization active quotas """

        queryset = self.filter_query(self.queryset)  # return by search param or all objects

        organization = get_organization_by_user(request.user)

        # paginate queryset
        page = self.paginate_queryset(
            queryset.filter(
                Q(registerer_organization=organization),
                Q(is_closed=False)
            ).order_by('-modify_date')
        )
        if page is not None:
            serializer = self.get_serializer(page, many=True)
            return self.get_paginated_response(serializer.data)

    @action(
        methods=['get'],
        detail=False,
        url_path='closed_quotas',
        url_name='closed_quotas',
        name='closed_quotas'
    )
    @transaction.atomic
    def closed_quotas(self, request):
        """ list of organization closed quotas """

        queryset = self.filter_query(self.queryset)  # return by search param or all objects

        organization = get_organization_by_user(request.user)

        # paginate queryset
        page = self.paginate_queryset(
            queryset.filter(
                Q(registerer_organization=organization),
                Q(is_closed=True)
            ).order_by('-modify_date')
        )
        if page is not None:
            serializer = self.get_serializer(page, many=True)
            return self.get_paginated_response(serializer.data)

    @action(
        methods=['get'],
        detail=True,
        url_path='distributions_by_quota',
        url_name='distributions_by_quota',
        name='distributions_by_quota'
    )
    def get_distributions_by_quota(self, request, pk=None):
        """ list of distributions by quota """

        try:
            quota = self.get_object()
            queryset = self.filter_query(
                quota.distributions_assigned.all().order_by('-modify_date')
            )  # return by search param or all objects

            # paginate queryset
            page = self.paginate_queryset(
                queryset
            )
            if page is not None:
                serializer = quota_distribution_serializers.QuotaDistributionSerializer(
                    page, many=True
                )
                return self.get_paginated_response(serializer.data)
        except Exception as e:
            raise APIException("none object", code=403)

    @action(
        methods=['get'],
        detail=True,
        url_path='quotas_information',
        url_name='quotas_information',
        name='quotas_information'
    )
    @transaction.atomic
    def quotas_information_by_product(self, request, pk=None):
        """ get quotas information of a product """

        quotas = self.queryset.select_related('product').filter(
            product_id=pk, is_closed=False
        )

        try:
            quota_serializer = self.serializer_class(quotas, many=True).data
            return Response(quota_serializer, status=status.HTTP_200_OK)
        except APIException as e:
            raise APIException(detail="data error", code=400)

    @action(
        methods=['get'],
        detail=False,
        url_path='quotas_info_by_org',
        url_name='quotas_info_by_org',
        name='quotas_info_by_org'
    )
    def quotas_information_by_organization(self, request):
        """ get quotas information of an organization """

        quotas = self.queryset.filter(
            Q(assigned_organizations=get_organization_by_user(request.user)) |
            Q(registerer_organization=get_organization_by_user(request.user))
        )

        serializer = self.serializer_class(quotas, many=True).data
        return Response(serializer, status=status.HTTP_200_OK)

    @action(
        methods=['put'],
        detail=True,
        url_path='trash',
        url_name='trash',
        name='trash',
    )
    @transaction.atomic
    def trash(self, request, pk=None):
        """ Sent quota to trash """
        try:
            trash(self.queryset, pk)
        except APIException as e:
            return Response(e, status.HTTP_204_NO_CONTENT)

    @action(
        methods=['post'],
        detail=True,
        url_name='delete',
        url_path='delete',
        name='delete'
    )
    @transaction.atomic
    def delete(self, request, pk=None):
        """ Full delete of quota object """
        try:
            delete(self.queryset, pk)
            return Response(status=status.HTTP_200_OK)
        except APIException as e:
            return Response(e, status=status.HTTP_204_NO_CONTENT)


class QuotaIncentiveAssignmentViewSet(viewsets.ModelViewSet, SoftDeleteMixin):  # noqa
    """ apis for incentive assignment """

    queryset = product_models.QuotaIncentiveAssignment.objects.all()
    serializer_class = quota_serializers.QuotaIncentiveAssignmentSerializer

    @action(
        methods=['put'],
        detail=True,
        url_path='trash',
        url_name='trash',
        name='trash',
    )
    @transaction.atomic
    def trash(self, request, pk=None):
        """ Sent quota incentive assignment to trash """
        try:
            trash(self.queryset, pk)
        except APIException as e:
            return Response(e, status.HTTP_204_NO_CONTENT)

    @action(
        methods=['post'],
        detail=True,
        url_name='delete',
        url_path='delete',
        name='delete'
    )
    @transaction.atomic
    def delete(self, request, pk=None):
        """ Full delete of quota incentive assignment object """
        try:
            delete(self.queryset, pk)
            return Response(status=status.HTTP_200_OK)
        except APIException as e:
            return Response(e, status=status.HTTP_204_NO_CONTENT)


class QuotaBrokerValueViewSet(viewsets.ModelViewSet, SoftDeleteMixin):  # noqa
    """ apis for quota broker value """

    queryset = product_models.QuotaBrokerValue.objects.all()
    serializer_class = quota_serializers.QuotaBrokerValueSerializer

    @action(
        methods=['put'],
        detail=True,
        url_path='trash',
        url_name='trash',
        name='trash',
    )
    @transaction.atomic
    def trash(self, request, pk=None):
        """ Sent quota broker value to trash """
        try:
            trash(self.queryset, pk)
        except APIException as e:
            return Response(e, status.HTTP_204_NO_CONTENT)

    @action(
        methods=['post'],
        detail=True,
        url_name='delete',
        url_path='delete',
        name='delete'
    )
    @transaction.atomic
    def delete(self, request, pk=None):
        """ Full delete of quota broker value object """
        try:
            delete(self.queryset, pk)
            return Response(status=status.HTTP_200_OK)
        except APIException as e:
            return Response(e, status=status.HTTP_204_NO_CONTENT)


class QuotaLiveStockAllocationViewSet(viewsets.ModelViewSet, SoftDeleteMixin):
    """ apis for quota livestock allocation """

    queryset = product_models.QuotaLivestockAllocation.objects.all()
    serializer_class = quota_serializers.QuotaLiveStockAllocationSerializer

    @action(
        methods=['put'],
        detail=True,
        url_path='trash',
        url_name='trash',
        name='trash',
    )
    @transaction.atomic
    def trash(self, request, pk=None):
        """ Sent quota livestock allocation to trash """
        try:
            trash(self.queryset, pk)
        except APIException as e:
            return Response(e, status.HTTP_204_NO_CONTENT)

    @action(
        methods=['post'],
        detail=True,
        url_name='delete',
        url_path='delete',
        name='delete'
    )
    @transaction.atomic
    def delete(self, request, pk=None):
        """ Full delete of quota livestock allocation object """
        try:
            delete(self.queryset, pk)
            return Response(status=status.HTTP_200_OK)
        except APIException as e:
            return Response(e, status=status.HTTP_204_NO_CONTENT)


class QuotaLiveStockAgeLimitation(viewsets.ModelViewSet, SoftDeleteMixin):
    queryset = product_models.QuotaLiveStockAgeLimitation.objects.all()  # noqa
    serializer_class = quota_serializers.QuotaLiveStockAgeLimitationSerializer

    @action(
        methods=['put'],
        detail=True,
        url_path='trash',
        url_name='trash',
        name='trash',
    )
    @transaction.atomic
    def trash(self, request, pk=None):
        """ Sent quota livestock age limitation to trash """
        try:
            trash(self.queryset, pk)
        except APIException as e:
            return Response(e, status.HTTP_204_NO_CONTENT)

    @action(
        methods=['post'],
        detail=True,
        url_name='delete',
        url_path='delete',
        name='delete'
    )
    @transaction.atomic
    def delete(self, request, pk=None):
        """ Full delete of quota livestock age limitation object """
        try:
            delete(self.queryset, pk)
            return Response(status=status.HTTP_200_OK)
        except APIException as e:
            return Response(e, status=status.HTTP_204_NO_CONTENT)
